/*
    Created by Quo
*/
 

--LOGS
-- Debug
INSERT INTO tblQuoDebug 
	(DebugID, 		x_Open, x_Close, 	Message)
VALUES ('Quo_Siege_Code',	'1',	'0',		'') ;


-- SIEGE
-- All siege units have a range of at least 3


-- Search for any units with siege characteristics in order to make sure units added by mods get this update
UPDATE Units SET Range=3 WHERE Range <=2 AND PromotionClass='PROMOTION_CLASS_SIEGE' ;


-- Lower them to 2 Move, but allow them to move and shoot on same turn
UPDATE Units SET BaseMoves=2 WHERE PromotionClass='PROMOTION_CLASS_SIEGE' ;

DELETE FROM TypeTags WHERE Type='ABILITY_NO_MOVE_AND_SHOOT' AND Tag='CLASS_SIEGE' AND (SELECT tblQuoOptions.Value FROM tblQuoOptions WHERE OptionID='QUO_OPTION_CAN_SIEGE_MOVE_AND_SHOOT' IS NOT 0);



-- Since there is a Unit Promotion that eliminates the move and shoot penalty, change it to +1 Movement

INSERT INTO Modifiers 
		(ModifierId, ModifierType, RunOnce, Permanent, OwnerRequirementSetId, SubjectRequirementSetId)
VALUES	('QUO_MOD_EXPERT_CREW_MOVE', 'MODIFIER_PLAYER_UNIT_ADJUST_MOVEMENT', 0, 0, NULL, NULL) ;


INSERT INTO ModifierArguments
	(ModifierId, 			Name, 		Type, 			Value, 		Extra, 	SecondExtra)
VALUES		('QUO_MOD_EXPERT_CREW_MOVE', 		'Amount', 	'ARGTYPE_IDENTITY', 	'1',		NULL, 	NULL) ;


INSERT INTO UnitPromotionModifiers
	(UnitPromotionType, 	ModifierId)
VALUES 	('PROMOTION_EXPERT_CREW',	'QUO_MOD_EXPERT_CREW_MOVE') ;

	
	

-- BATTERING RAM
-- Push back to Construction
-- Removed after changes to governments were reviewed
--UPDATE Units SET PrereqTech='TECH_CONSTRUCTION' WHERE UnitType='UNIT_BATTERING_RAM' ;



-- SIEGE TOWER
-- Remove by adding a trait no player can get
-- Note that altho we are using TRAIT_BARBARIAN, Barbs can't actually build this since its not on their build lists
UPDATE Units SET TraitType='TRAIT_BARBARIAN' WHERE UnitType='UNIT_SIEGE_TOWER' ;



-- Updated in v3.13.4 due to changes made by Firaxis
-- No more urban defenses from Steel. 
DELETE FROM TechnologyModifiers WHERE TechnologyType='TECH_STEEL' AND ModifierId='STEEL_UNLOCK_URBAN_DEFENSES' ;




-- UPDATE BUG TRACKER
-- This code should go last in every file


UPDATE tblQuoDebug SET x_Close='1' WHERE DebugID='Quo_Siege_Code';